/*
 * File:   ants.c
 * Author: cteam057
 *
 * Created on October 27, 2012, 12:39 PM
 */

#include <cstdlib>
#include <cstdio>

/*
 *
 */


int cycles, l;


int comp(const void* a, const void* b) {
        double * ax = (double*)a;
        double * bx = (double*)b;
        if(bx[0]<ax[0]) return 0;
        return 1;
    }


int main(int argc, char** argv) {
    int a;
    int i, p, j;
    char d;
    double **ants;
    
    while(scanf("%d %d", &l, &a)==2) {
        ants = (double**)malloc(sizeof(double)*a*4);
        cycles=0;
        for(i = 0; i < a; i++) {
            scanf("%d %c", &p, &d);
            ants[i][0]=p;
            ants[i][1]=p;
            if(d == 'L') {
                ants[i][2] = -0.5;
                if(p>cycles) cycles = p;
            } else {
                ants[i][2] = 0.5;
                if((l-p)>cycles) cycles = l-p;
            };
        }
        
        qsort(ants, a, sizeof(double*),comp);
        
        
        for(i = 0; i < cycles*2; i++) {
            ants[0][1] += ants[0][2];
            if(ants[0][2]) ants[0][3] = 1; else ants[0][3] = 0;
            if(ants[0][1]==0 || ants[0][1]==l) ants[0][2]=0;
            printf(" %.1lf %.1lf,", ants[0][1], ants[0][2]);
            for(j = 1; j < a; j++) {
                ants[j][1] += ants[j][2];
                if(ants[j][2]) ants[j][3] = 1; else ants[j][3] = 0;
                if(ants[j][1]==ants[j-1][1]) {
                    ants[j][2]*=-1;
                    ants[j-1][2]*=-1;
                    printf(" T");
                }
                if(ants[j][1]==0 || ants[j][1]==l) ants[j][2]=0;
                printf(" %.1lf %.1lf,", ants[j][1], ants[j][2]);
            }
            printf("\n");
        }
        
        printf("The last ant will fall down in %d seconds - started at ", cycles);
        j = 0;
        for(i = 0; i < a; i++) {
            if(ants[i][3]&&j==0) {
                j++;
                printf("%d", (int)ants[i][0]);
                continue;
            }
            if(ants[i][3]&&j==1) {
                printf(" and %d", (int)ants[i][0]);
                break;
            }
        }
        printf(".\n");
        
        free(ants);
    }
    return 0;
}

