/*
 * File:   ants.c
 * Author: cteam057
 *
 * Created on October 27, 2012, 12:39 PM
 */

#include <stdio.h>
#include <stdlib.h>

/*
 *
 */



int main(int argc, char** argv) {
    int l, a, cycles;
    int i, p, j;
    char d;
    int *start, *moved;
    double *pos, *state;
    
    while(scanf("%d %d", &l, &a)==2) {
        state = (double *) malloc(a*sizeof(double));
        pos = (double *) malloc(a*sizeof(double));
        start = (int *) malloc(a*sizeof(int));
        moved = (int *) malloc(a*sizeof(int));
        cycles=0;
        for(i = 0; i < a; i++) {
            scanf("%d %c", &p, &d);
            start[i]=p;
            pos[i]=p;
            if(d == 'L') {
                state[i] = -0.5;
                if(p>cycles) cycles = p;
            } else {
                state[i] = 0.5;
                if((l-p)>cycles) cycles = l-p;
            }
        }
        
        for(i = 0; i < cycles*2; i++) {
            pos[0] += state[0];
            if(state[0]) moved[0] = 1; else moved[0] = 0;
            if(pos[0]==0 || pos[0]==l) state[0]=0;
            printf(" %.1lf %.1lf,",pos[0],state[0]);
            for(j = 1; j < a; j++) {
                pos[j] += state[j];
                if(state[j]) moved[j] = 1; else moved[j] = 0;
                if(pos[j]==pos[j-1]) {
                    state[j]*=-1;
                    state[j-1]*=-1;
                    printf(" T");
                }
                if(pos[j]==0 || pos[j]==l) state[j]=0;
                printf(" %.1lf %.1lf,",pos[j],state[j]);
            }
            printf("\n");
        }
        
        printf("The last ant will fall down in %d seconds - started at ",cycles);
        j = 0;
        for(i = 0; i < a; i++) {
            if(moved[i]&&j==0) {
                j++;
                printf("%d",start[i]);
                continue;
            }
            if(moved[i]&&j==1) {
                printf(" and %d",start[i]);
                break;
            }
        }
        printf(".\n");
        
        free(moved);
        free(start);
        free(state);
        free(pos);
    }
    return 0;
}

